<html>
<head>
<title>OGRE: OgreAny.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreAny.h</h1><a href="OgreAny_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) Any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">Any WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="comment">// -- Based on boost::any, original copyright information follows --</span>
<a name="l00030"></a>00030 <span class="comment">// Copyright Kevlin Henney, 2000, 2001, 2002. All rights reserved.</span>
<a name="l00031"></a>00031 <span class="comment">//</span>
<a name="l00032"></a>00032 <span class="comment">// Distributed under the Boost Software License, Version 1.0. (See</span>
<a name="l00033"></a>00033 <span class="comment">// accompAnying file LICENSE_1_0.txt or copy at</span>
<a name="l00034"></a>00034 <span class="comment">// http://www.boost.org/LICENSE_1_0.txt)</span>
<a name="l00035"></a>00035 <span class="comment">// -- End original copyright --</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="preprocessor">#ifndef __OGRE_ANY_H__</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_ANY_H__</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include "<a class="code" href="OgreException_8h.html">OgreException.h</a>"</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &lt;typeinfo&gt;</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">namespace </span>Ogre
<a name="l00048"></a>00048 {
<a name="l00051"></a><a class="code" href="classOgre_1_1Any.html">00051</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>: <span class="comment">// constructors</span>
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classOgre_1_1Any.html#a7e584ce6897ef8c468404ba60996644">00055</a>         <a class="code" href="classOgre_1_1Any.html#a7e584ce6897ef8c468404ba60996644">Any</a>()
<a name="l00056"></a>00056           : <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>(0)
<a name="l00057"></a>00057         {
<a name="l00058"></a>00058         }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00061"></a><a class="code" href="classOgre_1_1Any.html#ac3dbac611065da73e1c9bb8373eb4fd">00061</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Any.html#a7e584ce6897ef8c468404ba60996644">Any</a>(<span class="keyword">const</span> ValueType &amp; value)
<a name="l00062"></a>00062           : <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>(new <a class="code" href="classOgre_1_1Any_1_1holder.html">holder</a>&lt;ValueType&gt;(value))
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classOgre_1_1Any.html#86f4cf2e8df053fc4a43ce2b8e07572d">00066</a>         <a class="code" href="classOgre_1_1Any.html#a7e584ce6897ef8c468404ba60996644">Any</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> &amp; other)
<a name="l00067"></a>00067           : <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>(other.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a> ? other.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>-&gt;clone() : 0)
<a name="l00068"></a>00068         {
<a name="l00069"></a>00069         }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classOgre_1_1Any.html#dc16537bcc7e1ef5ea0a0cae7bbc37bc">00071</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Any.html#dc16537bcc7e1ef5ea0a0cae7bbc37bc">~Any</a>()
<a name="l00072"></a>00072         {
<a name="l00073"></a>00073             <span class="keyword">delete</span> <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>;
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keyword">public</span>: <span class="comment">// modifiers</span>
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classOgre_1_1Any.html#8e18c614d89437e11df1b8defe85ea2e">00078</a>         <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1Any.html#8e18c614d89437e11df1b8defe85ea2e">swap</a>(<a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> &amp; rhs)
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080             std::swap(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>, rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>);
<a name="l00081"></a>00081             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00085"></a><a class="code" href="classOgre_1_1Any.html#8faca9b09747949f65fb191c7963c7e1">00085</a>         <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1Any.html#8faca9b09747949f65fb191c7963c7e1">operator=</a>(<span class="keyword">const</span> ValueType &amp; rhs)
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087             <a class="code" href="classOgre_1_1Any.html#a7e584ce6897ef8c468404ba60996644">Any</a>(rhs).swap(*<span class="keyword">this</span>);
<a name="l00088"></a>00088             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00089"></a>00089         }
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classOgre_1_1Any.html#b714694739f9a50a361f3087e2188c94">00091</a>         <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> &amp; <a class="code" href="classOgre_1_1Any.html#8faca9b09747949f65fb191c7963c7e1">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> &amp; rhs)
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093             <a class="code" href="classOgre_1_1Any.html#a7e584ce6897ef8c468404ba60996644">Any</a>(rhs).swap(*<span class="keyword">this</span>);
<a name="l00094"></a>00094             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00095"></a>00095         }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     <span class="keyword">public</span>: <span class="comment">// queries</span>
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classOgre_1_1Any.html#f6206a0377aaf42fbb1224a5fbaf6246">00099</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Any.html#f6206a0377aaf42fbb1224a5fbaf6246">isEmpty</a>()<span class="keyword"> const</span>
<a name="l00100"></a>00100 <span class="keyword">        </span>{
<a name="l00101"></a>00101             <span class="keywordflow">return</span> !<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>;
<a name="l00102"></a>00102         }
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classOgre_1_1Any.html#cbff05f938b211cb667dddcb46102722">00104</a>         <span class="keyword">const</span> std::type_info&amp; <a class="code" href="classOgre_1_1Any.html#cbff05f938b211cb667dddcb46102722">getType</a>()<span class="keyword"> const</span>
<a name="l00105"></a>00105 <span class="keyword">        </span>{
<a name="l00106"></a>00106             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a> ? <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>-&gt;<a class="code" href="classOgre_1_1Any_1_1placeholder.html#dbffede1819fffac5df00b2456d485ba">getType</a>() : <span class="keyword">typeid</span>(void);
<a name="l00107"></a>00107         }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         <span class="keyword">inline</span> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00110"></a><a class="code" href="classOgre_1_1Any.html#deded586bbc395a3e2d075d63c19f0f6">00110</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; v )
<a name="l00111"></a>00111         {
<a name="l00112"></a>00112             <span class="keywordflow">if</span> (v.mContent)
<a name="l00113"></a>00113                 v.mContent-&gt;writeToStream(o);
<a name="l00114"></a>00114             <span class="keywordflow">return</span> o;
<a name="l00115"></a>00115         }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118     <span class="keyword">protected</span>: <span class="comment">// types</span>
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classOgre_1_1Any_1_1placeholder.html">00120</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Any_1_1placeholder.html">placeholder</a>
<a name="l00121"></a>00121         {
<a name="l00122"></a>00122         <span class="keyword">public</span>: <span class="comment">// structors</span>
<a name="l00123"></a>00123     
<a name="l00124"></a><a class="code" href="classOgre_1_1Any_1_1placeholder.html#d122e24bf73e447ee0a34066598a4866">00124</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Any_1_1placeholder.html#d122e24bf73e447ee0a34066598a4866">~placeholder</a>()
<a name="l00125"></a>00125             {
<a name="l00126"></a>00126             }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         <span class="keyword">public</span>: <span class="comment">// queries</span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130             <span class="keyword">virtual</span> <span class="keyword">const</span> std::type_info&amp; <a class="code" href="classOgre_1_1Any_1_1placeholder.html#dbffede1819fffac5df00b2456d485ba">getType</a>() <span class="keyword">const</span> = 0;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Any_1_1placeholder.html">placeholder</a> * <a class="code" href="classOgre_1_1Any_1_1placeholder.html#d445f6f56c8869809d9619707fbbe671">clone</a>() <span class="keyword">const</span> = 0;
<a name="l00133"></a>00133     
<a name="l00134"></a>00134             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Any_1_1placeholder.html#c8109f388caa8709eab98200fd6aab5b">writeToStream</a>(std::ostream&amp; o) = 0;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         };
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00139"></a><a class="code" href="classOgre_1_1Any_1_1holder.html">00139</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1Any_1_1holder.html">holder</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Any_1_1placeholder.html">placeholder</a>
<a name="l00140"></a>00140         {
<a name="l00141"></a>00141         <span class="keyword">public</span>: <span class="comment">// structors</span>
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classOgre_1_1Any_1_1holder.html#803b4e5fdf898de9072da835bedcd9d8">00143</a>             <a class="code" href="classOgre_1_1Any_1_1holder.html#803b4e5fdf898de9072da835bedcd9d8">holder</a>(<span class="keyword">const</span> ValueType &amp; value)
<a name="l00144"></a>00144               : <a class="code" href="classOgre_1_1Any_1_1holder.html#70556b17407a80c23564be7c12c80c8b">held</a>(value)
<a name="l00145"></a>00145             {
<a name="l00146"></a>00146             }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148         <span class="keyword">public</span>: <span class="comment">// queries</span>
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classOgre_1_1Any_1_1holder.html#56afb766401eb023cbefc760a7d9c984">00150</a>             <span class="keyword">virtual</span> <span class="keyword">const</span> std::type_info &amp; <a class="code" href="classOgre_1_1Any_1_1holder.html#56afb766401eb023cbefc760a7d9c984">getType</a>()<span class="keyword"> const</span>
<a name="l00151"></a>00151 <span class="keyword">            </span>{
<a name="l00152"></a>00152                 <span class="keywordflow">return</span> <span class="keyword">typeid</span>(ValueType);
<a name="l00153"></a>00153             }
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classOgre_1_1Any_1_1holder.html#92b6d40054444e8fce5e47f091f63c50">00155</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Any_1_1placeholder.html">placeholder</a> * <a class="code" href="classOgre_1_1Any_1_1holder.html#92b6d40054444e8fce5e47f091f63c50">clone</a>()<span class="keyword"> const</span>
<a name="l00156"></a>00156 <span class="keyword">            </span>{
<a name="l00157"></a>00157                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1Any_1_1holder.html#803b4e5fdf898de9072da835bedcd9d8">holder</a>(<a class="code" href="classOgre_1_1Any_1_1holder.html#70556b17407a80c23564be7c12c80c8b">held</a>);
<a name="l00158"></a>00158             }
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classOgre_1_1Any_1_1holder.html#5877c5d406ad50d82277f0f85444f2e0">00160</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Any_1_1holder.html#5877c5d406ad50d82277f0f85444f2e0">writeToStream</a>(std::ostream&amp; o)
<a name="l00161"></a>00161             {
<a name="l00162"></a>00162                 o &lt;&lt; <a class="code" href="classOgre_1_1Any_1_1holder.html#70556b17407a80c23564be7c12c80c8b">held</a>;
<a name="l00163"></a>00163             }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="keyword">public</span>: <span class="comment">// representation</span>
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classOgre_1_1Any_1_1holder.html#70556b17407a80c23564be7c12c80c8b">00168</a>             ValueType <a class="code" href="classOgre_1_1Any_1_1holder.html#70556b17407a80c23564be7c12c80c8b">held</a>;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170         };
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="keyword">protected</span>: <span class="comment">// representation</span>
<a name="l00175"></a><a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">00175</a>         <a class="code" href="classOgre_1_1Any_1_1placeholder.html">placeholder</a> * <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00178"></a>00178         <span class="keyword">friend</span> ValueType * <a class="code" href="classOgre_1_1Any.html#d386f3fa16eb4c0e860d70c92a9e16dd">any_cast</a>(<a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> *);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     <span class="keyword">public</span>: 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00184"></a><a class="code" href="classOgre_1_1Any.html#4d704178de8d4c025248da486385ac75">00184</a>         ValueType <a class="code" href="classOgre_1_1Any.html#4d704178de8d4c025248da486385ac75">operator()</a>()<span class="keyword"> const</span>
<a name="l00185"></a>00185 <span class="keyword">        </span>{
<a name="l00186"></a>00186             <span class="keywordflow">if</span> (!<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>) 
<a name="l00187"></a>00187             {
<a name="l00188"></a>00188                 <a class="code" href="OgreException_8h.html#6d8a74980f0e08e2a912cddc19be0fcd">OGRE_EXCEPT</a>(<a class="code" href="classOgre_1_1Exception.html#9bdf9b8a0a83b95818d676848beaa29b359c10b8abe9abf39f84550a903e4698">Exception::ERR_INVALIDPARAMS</a>,
<a name="l00189"></a>00189                     <span class="stringliteral">"Bad cast from uninitialised Any"</span>, 
<a name="l00190"></a>00190                     <span class="stringliteral">"Any::operator()"</span>);
<a name="l00191"></a>00191             }
<a name="l00192"></a>00192             <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code" href="classOgre_1_1Any.html#cbff05f938b211cb667dddcb46102722">getType</a>() == <span class="keyword">typeid</span>(ValueType))
<a name="l00193"></a>00193             {
<a name="l00194"></a>00194                 <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Any_1_1holder.html">Any::holder&lt;ValueType&gt;</a> *<span class="keyword">&gt;</span>(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;held;
<a name="l00195"></a>00195             }
<a name="l00196"></a>00196             <span class="keywordflow">else</span>
<a name="l00197"></a>00197             {
<a name="l00198"></a>00198                 <a class="code" href="classOgre_1_1StringUtil.html#ad3e31a0bb6592035b9e646a2bd9f0dc">StringUtil::StrStreamType</a> str;
<a name="l00199"></a>00199                 str &lt;&lt; <span class="stringliteral">"Bad cast from type '"</span> &lt;&lt; <a class="code" href="classOgre_1_1Any.html#cbff05f938b211cb667dddcb46102722">getType</a>().name() &lt;&lt; <span class="stringliteral">"' "</span>
<a name="l00200"></a>00200                     &lt;&lt; <span class="stringliteral">"to '"</span> &lt;&lt; <span class="keyword">typeid</span>(ValueType).name() &lt;&lt; <span class="stringliteral">"'"</span>;
<a name="l00201"></a>00201                 <a class="code" href="OgreException_8h.html#6d8a74980f0e08e2a912cddc19be0fcd">OGRE_EXCEPT</a>(<a class="code" href="classOgre_1_1Exception.html#9bdf9b8a0a83b95818d676848beaa29b359c10b8abe9abf39f84550a903e4698">Exception::ERR_INVALIDPARAMS</a>,
<a name="l00202"></a>00202                      str.str(), 
<a name="l00203"></a>00203                     <span class="stringliteral">"Any::operator()"</span>);
<a name="l00204"></a>00204             }
<a name="l00205"></a>00205         }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207         
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     };
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00215"></a><a class="code" href="classOgre_1_1AnyNumeric.html">00215</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>
<a name="l00216"></a>00216     {
<a name="l00217"></a>00217     <span class="keyword">public</span>:
<a name="l00218"></a><a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">00218</a>         <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>()
<a name="l00219"></a>00219         : <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>()
<a name="l00220"></a>00220         {
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00224"></a><a class="code" href="classOgre_1_1AnyNumeric.html#a6bbcc98cfd2788e894f9443d81a22d1">00224</a>         <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(<span class="keyword">const</span> ValueType &amp; value)
<a name="l00225"></a>00225             
<a name="l00226"></a>00226         {
<a name="l00227"></a>00227             <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a> = <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html">numholder&lt;ValueType&gt;</a>(value);
<a name="l00228"></a>00228         }
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="classOgre_1_1AnyNumeric.html#9ae2045cc85e7a8e134d54e0babc2a3f">00230</a>         <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> &amp; other)
<a name="l00231"></a>00231             : <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>()
<a name="l00232"></a>00232         {
<a name="l00233"></a>00233             <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a> = other.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a> ? other.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>-&gt;<a class="code" href="classOgre_1_1Any_1_1placeholder.html#d445f6f56c8869809d9619707fbbe671">clone</a>() : 0; 
<a name="l00234"></a>00234         }
<a name="l00235"></a>00235     <span class="keyword">protected</span>:
<a name="l00236"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html">00236</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html">numplaceholder</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>::placeholder
<a name="l00237"></a>00237         {
<a name="l00238"></a>00238         <span class="keyword">public</span>: <span class="comment">// structors</span>
<a name="l00239"></a>00239 
<a name="l00240"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html#0fc12f0f9daac95af59b02f5ecdd4f1f">00240</a>             <a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html#0fc12f0f9daac95af59b02f5ecdd4f1f">~numplaceholder</a>()
<a name="l00241"></a>00241             {
<a name="l00242"></a>00242             }
<a name="l00243"></a>00243             <span class="keyword">virtual</span> placeholder* <span class="keyword">add</span>(placeholder* rhs) = 0;
<a name="l00244"></a>00244             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html#59c82a0733cbcb1fcc662ebe8c98b7a7">subtract</a>(placeholder* rhs) = 0;
<a name="l00245"></a>00245             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html#10a7671b8f9cb821fb5d720c3457358b">multiply</a>(placeholder* rhs) = 0;
<a name="l00246"></a>00246             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html#10a7671b8f9cb821fb5d720c3457358b">multiply</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor) = 0;
<a name="l00247"></a>00247             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html#cbf4855254ff7aefc864293d5da97ab4">divide</a>(placeholder* rhs) = 0;
<a name="l00248"></a>00248         };
<a name="l00249"></a>00249 
<a name="l00250"></a>00250         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00251"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html">00251</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html">numholder</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numplaceholder.html">numplaceholder</a>
<a name="l00252"></a>00252         {
<a name="l00253"></a>00253         <span class="keyword">public</span>: <span class="comment">// structors</span>
<a name="l00254"></a>00254 
<a name="l00255"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">00255</a>             <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<span class="keyword">const</span> ValueType &amp; value)
<a name="l00256"></a>00256                 : <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>(value)
<a name="l00257"></a>00257             {
<a name="l00258"></a>00258             }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260         <span class="keyword">public</span>: <span class="comment">// queries</span>
<a name="l00261"></a>00261 
<a name="l00262"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#30747552f8f12160cab496cf7b0d3e23">00262</a>             <span class="keyword">virtual</span> <span class="keyword">const</span> std::type_info &amp; <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#30747552f8f12160cab496cf7b0d3e23">getType</a>()<span class="keyword"> const</span>
<a name="l00263"></a>00263 <span class="keyword">            </span>{
<a name="l00264"></a>00264                 <span class="keywordflow">return</span> <span class="keyword">typeid</span>(ValueType);
<a name="l00265"></a>00265             }
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#8f39c28d0d67fec960573196e5e462a7">00267</a>             <span class="keyword">virtual</span> placeholder * <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#8f39c28d0d67fec960573196e5e462a7">clone</a>()<span class="keyword"> const</span>
<a name="l00268"></a>00268 <span class="keyword">            </span>{
<a name="l00269"></a>00269                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>);
<a name="l00270"></a>00270             }
<a name="l00271"></a>00271 
<a name="l00272"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#2720b7413df1f0384dc6a53f618a5776">00272</a>             <span class="keyword">virtual</span> placeholder* <span class="keyword">add</span>(placeholder* rhs)
<a name="l00273"></a>00273             {
<a name="l00274"></a>00274                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a> + static_cast&lt;numholder*&gt;(rhs)-&gt;<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>);
<a name="l00275"></a>00275             }
<a name="l00276"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#28c881c1c5e62ebeb79d451f059fbed4">00276</a>             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#28c881c1c5e62ebeb79d451f059fbed4">subtract</a>(placeholder* rhs)
<a name="l00277"></a>00277             {
<a name="l00278"></a>00278                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a> - static_cast&lt;numholder*&gt;(rhs)-&gt;<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>);
<a name="l00279"></a>00279             }
<a name="l00280"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#09ef8fec011588204b5ffc4c00770526">00280</a>             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#09ef8fec011588204b5ffc4c00770526">multiply</a>(placeholder* rhs)
<a name="l00281"></a>00281             {
<a name="l00282"></a>00282                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a> * static_cast&lt;numholder*&gt;(rhs)-&gt;<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>);
<a name="l00283"></a>00283             }
<a name="l00284"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#582605d2ca14d373552fc099760a346a">00284</a>             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#09ef8fec011588204b5ffc4c00770526">multiply</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor)
<a name="l00285"></a>00285             {
<a name="l00286"></a>00286                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a> * factor);
<a name="l00287"></a>00287             }
<a name="l00288"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#5df1d61d12c35b1abc587ea2323ec1f5">00288</a>             <span class="keyword">virtual</span> placeholder* <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#5df1d61d12c35b1abc587ea2323ec1f5">divide</a>(placeholder* rhs)
<a name="l00289"></a>00289             {
<a name="l00290"></a>00290                 <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#b9414baa5ac2efe6abe7486d4287d137">numholder</a>(<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a> / static_cast&lt;numholder*&gt;(rhs)-&gt;<a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>);
<a name="l00291"></a>00291             }
<a name="l00292"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#1cd19a31e8c9e9f73824e2db792bf629">00292</a>             <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#1cd19a31e8c9e9f73824e2db792bf629">writeToStream</a>(std::ostream&amp; o)
<a name="l00293"></a>00293             {
<a name="l00294"></a>00294                 o &lt;&lt; <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>;
<a name="l00295"></a>00295             }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297         <span class="keyword">public</span>: <span class="comment">// representation</span>
<a name="l00298"></a>00298 
<a name="l00299"></a><a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">00299</a>             ValueType <a class="code" href="classOgre_1_1AnyNumeric_1_1numholder.html#f70c75bcdb763868f6c40591a1e64699">held</a>;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301         };
<a name="l00302"></a>00302 
<a name="l00304"></a><a class="code" href="classOgre_1_1AnyNumeric.html#58c2548951abc9a76f4b4a36a1696d73">00304</a>         <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(placeholder* pholder)
<a name="l00305"></a>00305         {
<a name="l00306"></a>00306             <a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a> = pholder;
<a name="l00307"></a>00307         }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309     <span class="keyword">public</span>:
<a name="l00310"></a><a class="code" href="classOgre_1_1AnyNumeric.html#e50aea5f19e2fd3957eebbd688c0a533">00310</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> &amp; <a class="code" href="classOgre_1_1AnyNumeric.html#e50aea5f19e2fd3957eebbd688c0a533">operator=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> &amp; rhs)
<a name="l00311"></a>00311         {
<a name="l00312"></a>00312             <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(rhs).swap(*<span class="keyword">this</span>);
<a name="l00313"></a>00313             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00314"></a>00314         }
<a name="l00315"></a><a class="code" href="classOgre_1_1AnyNumeric.html#00fd7a417079429e2fd6b3622b51749f">00315</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> <a class="code" href="classOgre_1_1AnyNumeric.html#00fd7a417079429e2fd6b3622b51749f">operator+</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00316"></a>00316 <span class="keyword">        </span>{
<a name="l00317"></a>00317             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00318"></a>00318                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;<span class="keyword">add</span>(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00319"></a>00319         }
<a name="l00320"></a><a class="code" href="classOgre_1_1AnyNumeric.html#298def7d35b38a3751d396a26cbe0137">00320</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> <a class="code" href="classOgre_1_1AnyNumeric.html#298def7d35b38a3751d396a26cbe0137">operator-</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00321"></a>00321 <span class="keyword">        </span>{
<a name="l00322"></a>00322             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00323"></a>00323                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;subtract(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00324"></a>00324         }
<a name="l00325"></a><a class="code" href="classOgre_1_1AnyNumeric.html#4e66ac542966477326594bbcaff6c1bf">00325</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> <a class="code" href="classOgre_1_1AnyNumeric.html#4e66ac542966477326594bbcaff6c1bf">operator*</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00326"></a>00326 <span class="keyword">        </span>{
<a name="l00327"></a>00327             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00328"></a>00328                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;multiply(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00329"></a>00329         }
<a name="l00330"></a><a class="code" href="classOgre_1_1AnyNumeric.html#ee6cd64fb5fead543f31223cb007057e">00330</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> <a class="code" href="classOgre_1_1AnyNumeric.html#4e66ac542966477326594bbcaff6c1bf">operator*</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor)<span class="keyword"> const</span>
<a name="l00331"></a>00331 <span class="keyword">        </span>{
<a name="l00332"></a>00332             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00333"></a>00333                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;multiply(factor));
<a name="l00334"></a>00334         }
<a name="l00335"></a><a class="code" href="classOgre_1_1AnyNumeric.html#42655948f62f8795f0e1133c38aa4d8e">00335</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a> <a class="code" href="classOgre_1_1AnyNumeric.html#42655948f62f8795f0e1133c38aa4d8e">operator/</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00336"></a>00336 <span class="keyword">        </span>{
<a name="l00337"></a>00337             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00338"></a>00338                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;divide(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00339"></a>00339         }
<a name="l00340"></a><a class="code" href="classOgre_1_1AnyNumeric.html#a4087f5136e423b245fd620527e2966f">00340</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; <a class="code" href="classOgre_1_1AnyNumeric.html#a4087f5136e423b245fd620527e2966f">operator+=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)
<a name="l00341"></a>00341         {
<a name="l00342"></a>00342             *<span class="keyword">this</span> = <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00343"></a>00343                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;<span class="keyword">add</span>(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00344"></a>00344             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00345"></a>00345         }
<a name="l00346"></a><a class="code" href="classOgre_1_1AnyNumeric.html#826b7eaea253ac06098fec4002c5c768">00346</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; <a class="code" href="classOgre_1_1AnyNumeric.html#826b7eaea253ac06098fec4002c5c768">operator-=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)
<a name="l00347"></a>00347         {
<a name="l00348"></a>00348             *<span class="keyword">this</span> = <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00349"></a>00349                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;subtract(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00350"></a>00350             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00351"></a>00351         }
<a name="l00352"></a><a class="code" href="classOgre_1_1AnyNumeric.html#3f0b93de432f171f191d323fd181b2b0">00352</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; <a class="code" href="classOgre_1_1AnyNumeric.html#3f0b93de432f171f191d323fd181b2b0">operator*=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)
<a name="l00353"></a>00353         {
<a name="l00354"></a>00354             *<span class="keyword">this</span> = <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00355"></a>00355                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;multiply(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00356"></a>00356             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00357"></a>00357         }
<a name="l00358"></a><a class="code" href="classOgre_1_1AnyNumeric.html#45c2fcf50e3b46055c7cf4f31dbd49f5">00358</a>         <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; <a class="code" href="classOgre_1_1AnyNumeric.html#45c2fcf50e3b46055c7cf4f31dbd49f5">operator/=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnyNumeric.html" title="Specialised Any class which has built in arithmetic operators, but can hold only...">AnyNumeric</a>&amp; rhs)
<a name="l00359"></a>00359         {
<a name="l00360"></a>00360             *<span class="keyword">this</span> = <a class="code" href="classOgre_1_1AnyNumeric.html#e46b3b0ebe2e956031cfa3f771087708">AnyNumeric</a>(
<a name="l00361"></a>00361                 static_cast&lt;numplaceholder*&gt;(<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;divide(rhs.<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>));
<a name="l00362"></a>00362             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00363"></a>00363         }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368     };
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00372"></a><a class="code" href="namespaceOgre.html#7e84acb572a287422e0ec01ee05a415b">00372</a>     ValueType * <a class="code" href="namespaceOgre.html#7e84acb572a287422e0ec01ee05a415b">any_cast</a>(<a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> * operand)
<a name="l00373"></a>00373     {
<a name="l00374"></a>00374         <span class="keywordflow">return</span> operand &amp;&amp; operand-&gt;<a class="code" href="classOgre_1_1Any.html#cbff05f938b211cb667dddcb46102722">getType</a>() == <span class="keyword">typeid</span>(ValueType)
<a name="l00375"></a>00375                     ? &amp;<span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Any_1_1holder.html">Any::holder&lt;ValueType&gt;</a> *<span class="keyword">&gt;</span>(operand-&gt;<a class="code" href="classOgre_1_1Any.html#9a6bedddda6079058335bb8e78497445">mContent</a>)-&gt;held
<a name="l00376"></a>00376                     : 0;
<a name="l00377"></a>00377     }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00380"></a><a class="code" href="namespaceOgre.html#a8c3ed189e03dfaa9d5c1135b6f94f99">00380</a>     <span class="keyword">const</span> ValueType * <a class="code" href="namespaceOgre.html#7e84acb572a287422e0ec01ee05a415b">any_cast</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> * operand)
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382         <span class="keywordflow">return</span> <a class="code" href="namespaceOgre.html#7e84acb572a287422e0ec01ee05a415b">any_cast</a>&lt;ValueType&gt;(<span class="keyword">const_cast&lt;</span><a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> *<span class="keyword">&gt;</span>(operand));
<a name="l00383"></a>00383     }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385     <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ValueType&gt;
<a name="l00386"></a><a class="code" href="namespaceOgre.html#af49a79a11723c36dc1c2296fa16e454">00386</a>     ValueType <a class="code" href="namespaceOgre.html#7e84acb572a287422e0ec01ee05a415b">any_cast</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> &amp; operand)
<a name="l00387"></a>00387     {
<a name="l00388"></a>00388         <span class="keyword">const</span> ValueType * result = <a class="code" href="namespaceOgre.html#7e84acb572a287422e0ec01ee05a415b">any_cast</a>&lt;ValueType&gt;(&amp;operand);
<a name="l00389"></a>00389         <span class="keywordflow">if</span>(!result)
<a name="l00390"></a>00390         {
<a name="l00391"></a>00391             <a class="code" href="classOgre_1_1StringUtil.html#ad3e31a0bb6592035b9e646a2bd9f0dc">StringUtil::StrStreamType</a> str;
<a name="l00392"></a>00392             str &lt;&lt; <span class="stringliteral">"Bad cast from type '"</span> &lt;&lt; operand.<a class="code" href="classOgre_1_1Any.html#cbff05f938b211cb667dddcb46102722">getType</a>().name() &lt;&lt; <span class="stringliteral">"' "</span>
<a name="l00393"></a>00393                 &lt;&lt; <span class="stringliteral">"to '"</span> &lt;&lt; <span class="keyword">typeid</span>(ValueType).name() &lt;&lt; <span class="stringliteral">"'"</span>;
<a name="l00394"></a>00394             <a class="code" href="OgreException_8h.html#6d8a74980f0e08e2a912cddc19be0fcd">OGRE_EXCEPT</a>(<a class="code" href="classOgre_1_1Exception.html#9bdf9b8a0a83b95818d676848beaa29b359c10b8abe9abf39f84550a903e4698">Exception::ERR_INVALIDPARAMS</a>,
<a name="l00395"></a>00395                 str.str(), 
<a name="l00396"></a>00396                 <span class="stringliteral">"Ogre::any_cast"</span>);
<a name="l00397"></a>00397         }
<a name="l00398"></a>00398         <span class="keywordflow">return</span> *result;
<a name="l00399"></a>00399     }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 <span class="preprocessor">#endif</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:49 2008
</p>
</body>
</html>
